import'Shady.Manager.item'

local screenWidth, screenHeight = Turbine.UI.Display.GetSize()
local left, top = screenWidth / 2, screenHeight / 2

local currentState = {}
local refreshing = false

local function saveDB(s, a)
	for k in pairs(currentState) do
		currentState[k] = nil
	end
	for k in pairs(DB.plugins) do
		currentState[k] = true
		if a then
			Turbine.PluginManager.LoadPlugin(k)
		end
	end
	s.apply:SetEnabled(false)

	Turbine.PluginData.Save(Turbine.DataScope.Character, 'ShadyManagerDB', DB)

	if a then
		PluginLoaded()
	end
end

local function sorterMouseEnter(self, args)
	if sortBy[1] ~= self._id then
		--self:SetOpacity(0.5)
		--self:SetVisible(true)
		self:SetBackground('Shady/Manager/Resources/sortbarxh1.jpg')
	end
end
local function sorterMouseLeave(self, args)
	if sortBy[1] ~= self._id then
		--self:SetOpacity(0.0)
		--self:SetVisible(false)
		self:SetBackground('Shady/Manager/Resources/sortbar1.jpg')
	end
end
local function sorterMouseClick(self, args)
	if sortBy[1] ~= self._id then
		local old = self:GetParent().hovers[sortBy[1]]
		old:SetBackground('Shady/Manager/Resources/sortbar1.jpg')
		self:SetBackground('Shady/Manager/Resources/sortbarh1.jpg')

		old.sorted:SetVisible(false)
		self.sorted:SetVisible(true)

		sortAcsend = true
		if self._id == 1 then
			sortBy[1], sortBy[2], sortBy[3] = 1, 2, 3
		elseif self._id == 2 then
			sortBy[1], sortBy[2], sortBy[3] = 2, 1, 3
			sortAcsend = false
		elseif self._id == 3 then
			sortBy[1], sortBy[2], sortBy[3] = 3, 1, 2
		end
		sortPlugins()

		if sortAcsend then
			self.sorted:SetBackground('Shady/Manager/Resources/sortup.jpg')
		else
			self.sorted:SetBackground('Shady/Manager/Resources/sortdown.jpg')
		end

		self:GetParent():GetParent():Sorted()
	else
		sortAcsend =  not sortAcsend
		sortPlugins()

		if sortAcsend then
			self.sorted:SetBackground('Shady/Manager/Resources/sortup.jpg')
		else
			self.sorted:SetBackground('Shady/Manager/Resources/sortdown.jpg')
		end

		self:GetParent():GetParent():Sorted()
	end
end

Shady.Manager.window = Turbine.UI.Lotro.Window()

	window:SetSize(300, 400)
	window:SetPosition(left - (window:GetWidth() / 2), top - (window:GetHeight() / 2))
	window:SetZOrder(5)

	window:SetText(L'windowname')

	--window:SetVisible(true)

	window:SetWantsKeyEvents(true)
	window.KeyDown = function(sender, args)
		if args.Action == Turbine.UI.Lotro.Action.Escape then
			sender:SetVisible(false)
		end
	end

	window.listboxScrollbar = Turbine.UI.Lotro.ScrollBar()
	window.listboxScrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
	window.listboxScrollbar:SetParent(window)

	window.listbox = Turbine.UI.ListBox()
	window.listbox:SetParent(window)
	window.listbox:SetOrientation(Turbine.UI.Orientation.Vertical)
	window.listbox:SetVerticalScrollBar(window.listboxScrollbar)
	window.listbox:SetBackColorBlendMode(Turbine.UI.BlendMode.None)
	--window.listbox:SetBackColor(Turbine.UI.Color(0.5, 0, 1, 0))--lol oops

	window.apply = Turbine.UI.Lotro.Button()
	window.apply:SetParent(window)
	window.apply:SetEnabled(false)--only need to apply if something has changed
	--window.apply:SetPosition(15, 35)
	--window.apply:SetSize(listWidth, listHeight)
	window.apply:SetText(L'apply')
	window.apply:SetWidth(70)--default is 50
	window.apply.Click = function(sender, args)
		--save and load selected plugins
		saveDB(window, true)

		sortPlugins()
		window:Sorted()
	end

	--write(window.apply:GetWidth())

	window.reload = Turbine.UI.Lotro.Button()
	window.reload:SetParent(window)
	window.reload:SetEnabled(true)
	--window.reload:SetPosition(15, 35)
	--window.reload:SetSize(listWidth, listHeight)
	window.reload:SetText(L'reload')
	window.reload:SetWidth(70)--default is 50
	window.reload.Click = function(sender, args)
		--i should probably treat reload like Apply but also reloads plugins
		saveDB(window)

		--reload selected plugins
		UnloadAllPlugins()

		Turbine.UI.Lotro.LotroUI.Reset()

		LoadAllEnabledPlugins()

		sortPlugins()
		window:Sorted()
	end

--[[
	window.refresh.Click = function(sender,args)
		refreshing = true
		Turbine.PluginManager.RefreshAvailablePlugins()
		PluginLoaded()
	end
]]

	window.sortbg = Turbine.UI.Control()
	window.sortbg:SetParent(window)
	--window.sortbg:SetSize(itemSize, 18)
	window.sortbg:SetBackground('Shady/Manager/Resources/sortbar1.jpg')
	window.sortbg.hovers = {}

	--Enabled
	window.sortbg.hovers[2] = Turbine.UI.Control()
	window.sortbg.hovers[2]._id = 2
	window.sortbg.hovers[2]:SetParent(window.sortbg)
	window.sortbg.hovers[2]:SetPosition(0, 0)
	window.sortbg.hovers[2]:SetSize(17, 18)
	--window.sortbg.hovers[2]:SetBackground('Shady/Manager/Resources/sortbarh1.jpg')
	window.sortbg.hovers[2]:SetBackColorBlendMode(Turbine.UI.BlendMode.Screen)
	--window.sortbg.hovers[2]:SetVisible(false)
	--window.sortbg.hovers[2]:SetOpacity(0.0)
	window.sortbg.hovers[2].MouseEnter = sorterMouseEnter
	window.sortbg.hovers[2].MouseLeave = sorterMouseLeave
	window.sortbg.hovers[2].MouseClick = sorterMouseClick

	--name label
	window.sortbg.hovers[1] = Turbine.UI.Control()
	window.sortbg.hovers[1]._id = 1
	window.sortbg.hovers[1]:SetParent(window.sortbg)
	window.sortbg.hovers[1]:SetPosition(16 + 4, 0)
	window.sortbg.hovers[1]:SetSize((260 * 0.6) - (16 + 3), 18)--260 * 0.53
	window.sortbg.hovers[1]:SetBackground('Shady/Manager/Resources/sortbarh1.jpg')
	window.sortbg.hovers[1]:SetBackColorBlendMode(Turbine.UI.BlendMode.Screen)
	--window.sortbg.hovers[1]:SetVisible(false)
	--window.sortbg.hovers[1]:SetOpacity(0.0)
	window.sortbg.hovers[1].MouseEnter = sorterMouseEnter
	window.sortbg.hovers[1].MouseLeave = sorterMouseLeave
	window.sortbg.hovers[1].MouseClick = sorterMouseClick

	--author label
	window.sortbg.hovers[3] = Turbine.UI.Control()
	window.sortbg.hovers[3]._id = 3
	window.sortbg.hovers[3]:SetParent(window.sortbg)
	window.sortbg.hovers[3]:SetPosition((260 * 0.6) + 4, 0)
	window.sortbg.hovers[3]:SetSize((260 * 0.45) - (16 + 1), 18)
	--window.sortbg.hovers[3]:SetBackground('Shady/Manager/Resources/sortbarh1.jpg')
	window.sortbg.hovers[3]:SetBackColorBlendMode(Turbine.UI.BlendMode.Screen)
	--window.sortbg.hovers[3]:SetVisible(false)
	--window.sortbg.hovers[3]:SetOpacity(0.0)
	window.sortbg.hovers[3].MouseEnter = sorterMouseEnter
	window.sortbg.hovers[3].MouseLeave = sorterMouseLeave
	window.sortbg.hovers[3].MouseClick = sorterMouseClick

	window.label = Turbine.UI.Label()
	window.label:SetParent(window.sortbg)
	window.label:SetPosition(16 + 8, 2)--was + 5 instead of 8
	window.label:SetSize((260 * 0.6) - (16 + 5), 16)
	window.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	window.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
	window.label:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
	window.label:SetMouseVisible(false)
	window.label:SetText('Name')

	window.author = Turbine.UI.Label()
	window.author:SetParent(window.sortbg)
	window.author:SetPosition((260 * 0.6) + 8, 2)--was + 5 instead of 8
	window.author:SetSize((260 * 0.45) - (16 + 5), 16)
	window.author:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	window.author:SetFontStyle(Turbine.UI.FontStyle.Outline)
	window.author:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
	window.author:SetMouseVisible(false)
	window.author:SetText('Author')

	window.labeltab = Turbine.UI.Control()
	window.labeltab:SetParent(window.sortbg)
	window.labeltab:SetPosition(16 + 2, -1)
	window.labeltab:SetSize(2, 18)
	window.labeltab:SetBackground('Shady/Manager/Resources/sortbartab1.jpg')

	window.authortab = Turbine.UI.Control()
	window.authortab:SetParent(window.sortbg)
	window.authortab:SetPosition((260 * 0.6) + 2, -1)
	window.authortab:SetSize(2, 18)
	window.authortab:SetBackground('Shady/Manager/Resources/sortbartab1.jpg')

	window.sortbg.hovers[2].sorted = Turbine.UI.Control()
	window.sortbg.hovers[2].sorted:SetParent(window.sortbg)
	window.sortbg.hovers[2].sorted:SetPosition(7, 8)
	window.sortbg.hovers[2].sorted:SetSize(5, 3)
	window.sortbg.hovers[2].sorted:SetBackground('Shady/Manager/Resources/sortup.jpg')
	window.sortbg.hovers[2].sorted:SetMouseVisible(false)
	window.sortbg.hovers[2].sorted:SetVisible(false)

	local len = window.label:GetText():len()
	window.sortbg.hovers[1].sorted = Turbine.UI.Control()
	window.sortbg.hovers[1].sorted:SetParent(window.sortbg)
	window.sortbg.hovers[1].sorted:SetPosition(len * 14, 8)
	window.sortbg.hovers[1].sorted:SetSize(5, 3)
	window.sortbg.hovers[1].sorted:SetBackground('Shady/Manager/Resources/sortup.jpg')
	window.sortbg.hovers[1].sorted:SetMouseVisible(false)
	--window.sortbg.hovers[1].sorted:SetVisible(false)

	len = window.author:GetText():len()
	window.sortbg.hovers[3].sorted = Turbine.UI.Control()
	window.sortbg.hovers[3].sorted:SetParent(window.sortbg)
	window.sortbg.hovers[3].sorted:SetPosition((260 * 0.6) + (len * 9), 8)
	window.sortbg.hovers[3].sorted:SetSize(5, 3)
	window.sortbg.hovers[3].sorted:SetBackground('Shady/Manager/Resources/sortup.jpg')
	window.sortbg.hovers[3].sorted:SetMouseVisible(false)
	window.sortbg.hovers[3].sorted:SetVisible(false)

function window:UpdateRect()
	local width, height = self:GetSize()

	--sortbar will be 18 height

	local listWidth = width - 40
	local listHeight = height - 94

	self.listbox:SetPosition(15, 53)
	self.listbox:SetSize(listWidth, listHeight)
	--self.listbox:SetMaxItemsPerLine(1)

	self.listboxScrollbar:SetPosition(width - 25, 53)
	self.listboxScrollbar:SetSize(10, listHeight)

	local applyWidth = self.apply:GetWidth()
	local applyLeft = width - (applyWidth + 30)
	self.apply:SetPosition(applyLeft, height - 33)

	local reloadWidth = self.reload:GetWidth()
	self.reload:SetPosition(applyLeft - applyWidth, height - 33)

	self.sortbg:SetPosition(15, 33)--y was 35
	self.sortbg:SetSize(listWidth, 18)
end

window:UpdateRect()

function window:Show()
	self:SetVisible(true)
	--self:Activate()

	for k in pairs(currentState) do
		currentState[k] = nil
	end
	for k in pairs(DB.plugins) do
		currentState[k] = true
	end

	self:Sorted()
end

function window:Sorted()
	local pc = #_plugins - 1
	local lc = self.listbox:GetItemCount()

	--getting ready for refreshing plugins
	--if pc > lc remove extra items

	local i = 1
	for k,v in pairs(_plugins) do
		if v.Name ~= 'manager' then
			local r, s = pcall(self.listbox.GetItem, self.listbox, i)
			i = i + 1
			if not r or not s then
				s = item(v)
				self.listbox:AddItem(s)
			else
				s:SetPlugin(v)
			end

			s.label:SetText(v.Name)
			s.author:SetText(v.Author)

			s:SetChecked(DB.plugins[v.Name])
		end
	end

	self:ShowLoaded()
end

--function window:UpdateContent()
--end

--function window:VisibleChanged(args)
--	if self:IsVisible() then
--		self:UpdateContent()
--	end
--end

function window:Closing(args)
	--closing the window will act as a cancel and reset DB to what it was when the window opened
	if self.apply:IsEnabled() then
		for k in pairs(DB.plugins) do
			DB.plugins[k] = nil
		end
		for k in pairs(currentState) do
			DB.plugins[k] = true
		end
		Turbine.PluginData.Save(Turbine.DataScope.Character, 'ShadyManagerDB', DB)
		self.apply:SetEnabled(false)
	end
end

function window:Compare()
	local changed = false
	for k in pairs(DB.plugins) do
		if not currentState[k] then
			--plugin was disabled but now is enabled
			changed = true
			break
		end
	end
	if not changed then
		for k in pairs(currentState) do
			if not DB.plugins[k] then
				--plugin was enabled and now is disabled
				changed = true
				break
			end
		end
	end

	if changed then
		self.apply:SetEnabled(true)
	else
		self.apply:SetEnabled(false)
	end
end

function window:ShowLoaded()
	_loaded_plugins = Turbine.PluginManager.GetLoadedPlugins()

	local count = self.listbox:GetItemCount()
	for i = 1, count do
		local item = self.listbox:GetItem(i)
		local name = item:GetPlugin().Name
		local loaded = false
		for k,v in pairs(_loaded_plugins) do
			if name == v.Name then
				loaded = true
				break
			end
		end
		if loaded then
			item.label:SetForeColor(Turbine.UI.Color(0, 0.77, 0))
		else
			item.label:SetForeColor(Turbine.UI.Color(1, 1, 1))
		end
	end
end

function window:PluginLoaded()
	if not refreshing then
		--self:UpdateContent()
		self:ShowLoaded()
	else
		refreshing = false
		_plugins = Turbine.PluginManager.GetAvailablePlugins()--hmm
		self:Closing()
		self:Sorted()
	end
end

shellCommandReloadUI = Turbine.ShellCommand()
function shellCommandReloadUI:Execute(command, arguments)
	Shady.Manager.window.reload.Click()
end
function shellCommandReloadUI:GetHelp()
	return L'rlhelp'
end
function shellCommandReloadUI:GetShortHelp()
	return L'rlhelp'
end
Turbine.Shell.AddCommand('reloadui;rl', shellCommandReloadUI)
